Merge branch 'master' into cvs
authorJoey Hess <joey@gnu.kitenet.net>
Thu, 10 Sep 2009 20:18:23 +0000 (16:18 -0400)
committerJoey Hess <joey@gnu.kitenet.net>
Thu, 10 Sep 2009 20:18:23 +0000 (16:18 -0400)
IkiWiki.pm
IkiWiki/Plugin/cvs.pm [new file with mode: 0644]
IkiWiki/Receive.pm
IkiWiki/Render.pm
IkiWiki/Wrapper.pm
ikiwiki-makerepo
t/cvs.t [new file with mode: 0755]
t/file_pruned.t

index 187d40a3aa7107df352080a7c9811d574628d852..85d8eea68419cb350e530c322958796186e05b1f 100644 (file)
@@ -344,7 +344,7 @@ sub getsetup () {
                        qr/\.x?html?$/, qr/\.ikiwiki-new$/,
                        qr/(^|\/).svn\//, qr/.arch-ids\//, qr/{arch}\//,
                        qr/(^|\/)_MTN\//, qr/(^|\/)_darcs\//,
-                       qr/\.dpkg-tmp$/],
+                       qr/(^|\/)CVS\//, qr/\.dpkg-tmp$/],
                description => "regexps of source files to ignore",
                safe => 0,
                rebuild => 1,
diff --git a/IkiWiki/Plugin/cvs.pm b/IkiWiki/Plugin/cvs.pm
new file mode 100644 (file)
index 0000000..939e892
--- /dev/null
@@ -0,0 +1,458 @@
+#!/usr/pkg/bin/perl
+package IkiWiki::Plugin::cvs;
+
+use warnings;
+use strict;
+use IkiWiki;
+
+use File::chdir;
+
+sub import {
+       hook(type => "wrapperargcheck", id => "cvs", call => \&wrapperargcheck);
+       hook(type => "checkconfig", id => "cvs", call => \&checkconfig);
+       hook(type => "getsetup", id => "cvs", call => \&getsetup);
+       hook(type => "rcs", id => "rcs_update", call => \&rcs_update);
+       hook(type => "rcs", id => "rcs_prepedit", call => \&rcs_prepedit);
+       hook(type => "rcs", id => "rcs_commit", call => \&rcs_commit);
+       hook(type => "rcs", id => "rcs_commit_staged", call => \&rcs_commit_staged);
+       hook(type => "rcs", id => "rcs_add", call => \&rcs_add);
+       hook(type => "rcs", id => "rcs_remove", call => \&rcs_remove);
+       hook(type => "rcs", id => "rcs_rename", call => \&rcs_rename);
+       hook(type => "rcs", id => "rcs_recentchanges", call => \&rcs_recentchanges);
+       hook(type => "rcs", id => "rcs_diff", call => \&rcs_diff);
+       hook(type => "rcs", id => "rcs_getctime", call => \&rcs_getctime);
+}
+
+sub wrapperargcheck () {
+       my $check_args=<<"EOF";
+       int j;
+       for (j = 1; j < argc; j++)
+               if (strstr(argv[j], "New directory") != NULL)
+                       return 0;
+       return 1;
+EOF
+       return $check_args;
+}
+
+sub checkconfig () {
+       if (! defined $config{cvspath}) {
+               $config{cvspath}="ikiwiki";
+       }
+       if (exists $config{cvspath}) {
+               # code depends on the path not having extraneous slashes
+               $config{cvspath}=~tr#/#/#s;
+               $config{cvspath}=~s/\/$//;
+               $config{cvspath}=~s/^\///;
+       }
+       if (defined $config{cvs_wrapper} && length $config{cvs_wrapper}) {
+               push @{$config{wrappers}}, {
+                       wrapper => $config{cvs_wrapper},
+                       wrappermode => (defined $config{cvs_wrappermode} ? $config{cvs_wrappermode} : "04755"),
+               };
+       }
+}
+
+sub getsetup () {
+       return
+               plugin => {
+                       safe => 0, # rcs plugin
+                       rebuild => undef,
+               },
+               cvsrepo => {
+                       type => "string",
+                       example => "/cvs/wikirepo",
+                       description => "cvs repository location",
+                       safe => 0, # path
+                       rebuild => 0,
+               },
+               cvspath => {
+                       type => "string",
+                       example => "ikiwiki",
+                       description => "path inside repository where the wiki is located",
+                       safe => 0, # paranoia
+                       rebuild => 0,
+               },
+               cvs_wrapper => {
+                       type => "string",
+                       example => "/cvs/wikirepo/CVSROOT/post-commit",
+                       description => "cvs post-commit hook to generate (triggered by CVSROOT/loginfo entry)",
+                       safe => 0, # file
+                       rebuild => 0,
+               },
+               cvs_wrappermode => {
+                       type => "string",
+                       example => '04755',
+                       description => "mode for cvs_wrapper (can safely be made suid)",
+                       safe => 0,
+                       rebuild => 0,
+               },
+               historyurl => {
+                       type => "string",
+                       example => "http://cvs.example.org/cvsweb.cgi/ikiwiki/[[file]]",
+                       description => "cvsweb url to show file history ([[file]] substituted)",
+                       safe => 1,
+                       rebuild => 1,
+               },
+               diffurl => {
+                       type => "string",
+                       example => "http://cvs.example.org/cvsweb.cgi/ikiwiki/[[file]].diff?r1=text&amp;tr1=[[r1]]&amp;r2=text&amp;tr2=[[r2]]",
+                       description => "cvsweb url to show a diff ([[file]], [[r1]], and [[r2]] substituted)",
+                       safe => 1,
+                       rebuild => 1,
+               },
+}
+
+sub cvs_info ($$) {
+       my $field=shift;
+       my $file=shift;
+
+       local $CWD = $config{srcdir};
+
+       my $info=`cvs status $file`;
+       my ($ret)=$info=~/^\s*$field:\s*(\S+)/m;
+       return $ret;
+}
+
+sub cvs_runcvs(@) {
+       my @cmd = @_;
+       unshift @cmd, 'cvs', '-Q';
+
+       local $CWD = $config{srcdir};
+
+       open(my $savedout, ">&STDOUT");
+       open(STDOUT, ">", "/dev/null");
+       my $ret = system(@cmd);
+       open(STDOUT, ">&", $savedout);
+
+       return ($ret == 0) ? 1 : 0;
+}
+
+sub cvs_is_controlling {
+       my $dir=shift;
+       $dir=$config{srcdir} unless defined($dir);
+       return (-d "$dir/CVS") ? 1 : 0;
+}
+
+sub rcs_update () {
+       return unless cvs_is_controlling;
+       cvs_runcvs('update', '-dP');
+}
+
+sub rcs_prepedit ($) {
+       # Prepares to edit a file under revision control. Returns a token
+       # that must be passed into rcs_commit when the file is ready
+       # for committing.
+       # The file is relative to the srcdir.
+       my $file=shift;
+
+       return unless cvs_is_controlling;
+
+       # For cvs, return the revision of the file when
+       # editing begins.
+       my $rev=cvs_info("Repository revision", "$file");
+       return defined $rev ? $rev : "";
+}
+
+sub rcs_commit ($$$;$$) {
+       # Tries to commit the page; returns undef on _success_ and
+       # a version of the page with the rcs's conflict markers on failure.
+       # The file is relative to the srcdir.
+       my $file=shift;
+       my $message=shift;
+       my $rcstoken=shift;
+       my $user=shift;
+       my $ipaddr=shift;
+
+       return unless cvs_is_controlling;
+
+       if (defined $user) {
+               $message="web commit by $user".(length $message ? ": $message" : "");
+       }
+       elsif (defined $ipaddr) {
+               $message="web commit from $ipaddr".(length $message ? ": $message" : "");
+       }
+
+       # Check to see if the page has been changed by someone
+       # else since rcs_prepedit was called.
+       my ($oldrev)=$rcstoken=~/^([0-9]+)$/; # untaint
+       my $rev=cvs_info("Repository revision", "$config{srcdir}/$file");
+       if (defined $rev && defined $oldrev && $rev != $oldrev) {
+               # Merge their changes into the file that we've
+               # changed.
+               cvs_runcvs('update', $file) ||
+                       warn("cvs merge from $oldrev to $rev failed\n");
+       }
+
+       if (! cvs_runcvs('commit', '-m',
+                        IkiWiki::possibly_foolish_untaint $message)) {
+               my $conflict=readfile("$config{srcdir}/$file");
+               cvs_runcvs('update', '-C', $file) ||
+                       warn("cvs revert failed\n");
+               return $conflict;
+       }
+
+       return undef # success
+}
+
+sub rcs_commit_staged ($$$) {
+       # Commits all staged changes. Changes can be staged using rcs_add,
+       # rcs_remove, and rcs_rename.
+       my ($message, $user, $ipaddr)=@_;
+
+       if (defined $user) {
+               $message="web commit by $user".(length $message ? ": $message" : "");
+       }
+       elsif (defined $ipaddr) {
+               $message="web commit from $ipaddr".(length $message ? ": $message" : "");
+       }
+
+       if (! cvs_runcvs('commit', '-m',
+                        IkiWiki::possibly_foolish_untaint $message)) {
+               warn "cvs staged commit failed\n";
+               return 1; # failure
+       }
+       return undef # success
+}
+
+sub rcs_add ($) {
+       # filename is relative to the root of the srcdir
+       my $file=shift;
+       my $parent=IkiWiki::dirname($file);
+       my @files_to_add = ($file);
+
+       eval q{use File::MimeInfo};
+       error($@) if $@;
+
+       until ((length($parent) == 0) || cvs_is_controlling("$config{srcdir}/$parent")){
+               push @files_to_add, $parent;
+               $parent = IkiWiki::dirname($parent);
+       }
+
+       while ($file = pop @files_to_add) {
+               if (@files_to_add == 0) {
+                       # file
+                       my $filemime = File::MimeInfo::default($file);
+                       if (defined($filemime) && $filemime eq 'text/plain') {
+                               cvs_runcvs('add', $file) ||
+                                       warn("cvs add $file failed\n");
+                       }
+                       else {
+                               cvs_runcvs('add', '-kb', $file) ||
+                                       warn("cvs add binary $file failed\n");
+                       }
+               }
+               else {
+                       # directory
+                       cvs_runcvs('add', $file) ||
+                               warn("cvs add $file failed\n");
+               }
+       }
+}
+
+sub rcs_remove ($) {
+       # filename is relative to the root of the srcdir
+       my $file=shift;
+
+       return unless cvs_is_controlling;
+
+       cvs_runcvs('rm', '-f', $file) ||
+               warn("cvs rm $file failed\n");
+}
+
+sub rcs_rename ($$) {
+       # filenames relative to the root of the srcdir
+       my ($src, $dest)=@_;
+
+       return unless cvs_is_controlling;
+
+       local $CWD = $config{srcdir};
+
+       if (system("mv", "$src", "$dest") != 0) {
+               warn("filesystem rename failed\n");
+       }
+
+       rcs_add($dest);
+       rcs_remove($src);
+}
+
+sub rcs_recentchanges($) {
+       my $num = shift;
+       my @ret;
+
+       return unless cvs_is_controlling;
+
+       eval q{use Date::Parse};
+       error($@) if $@;
+
+       local $CWD = $config{srcdir};
+
+       # There's no cvsps option to get the last N changesets.
+       # Write full output to a temp file and read backwards.
+
+       eval q{use File::Temp qw/tempfile/};
+       error($@) if $@;
+       eval q{use File::ReadBackwards};
+       error($@) if $@;
+
+       my (undef, $tmpfile) = tempfile(OPEN=>0);
+       system("env TZ=UTC cvsps -q --cvs-direct -z 30 -x >$tmpfile");
+       if ($? == -1) {
+               error "couldn't run cvsps: $!\n";
+       } elsif (($? >> 8) != 0) {
+               error "cvsps exited " . ($? >> 8) . ": $!\n";
+       }
+
+       tie(*SPSVC, 'File::ReadBackwards', $tmpfile)
+               || error "couldn't open $tmpfile for read: $!\n";
+
+       while (my $line = <SPSVC>) {
+               $line =~ /^$/ || error "expected blank line, got $line";
+
+               my ($rev, $user, $committype, $when);
+               my (@message, @pages);
+
+               # We're reading backwards.
+               # Forwards, an entry looks like so:
+               # ---------------------
+               # PatchSet $rev
+               # Date: $when
+               # Author: $user (or user CGI runs as, for web commits)
+               # Branch: branch
+               # Tag: tag
+               # Log:
+               # @message_lines
+               # Members:
+               #       @pages (and revisions)
+               #
+
+               while ($line = <SPSVC>) {
+                       last if ($line =~ /^Members:/);
+                       for ($line) {
+                               s/^\s+//;
+                               s/\s+$//;
+                       }
+                       my ($page, $revs) = split(/:/, $line);
+                       my ($oldrev, $newrev) = split(/->/, $revs);
+                       $oldrev =~ s/INITIAL/0/;
+                       $newrev =~ s/\(DEAD\)//;
+                       my $diffurl = defined $config{diffurl} ? $config{diffurl} : "";
+                       $diffurl=~s/\[\[file\]\]/$page/g;
+                       $diffurl=~s/\[\[r1\]\]/$oldrev/g;
+                       $diffurl=~s/\[\[r2\]\]/$newrev/g;
+                       unshift @pages, {
+                               page => pagename($page),
+                               diffurl => $diffurl,
+                       } if length $page;
+               }
+
+               while ($line = <SPSVC>) {
+                       last if ($line =~ /^Log:$/);
+                       chomp $line;
+                       unshift @message, { line => $line };
+               }
+               $committype = "web";
+               if (defined $message[0] &&
+                   $message[0]->{line}=~/$config{web_commit_regexp}/) {
+                       $user=defined $2 ? "$2" : "$3";
+                       $message[0]->{line}=$4;
+               }
+               else {
+                       $committype="cvs";
+               }
+
+               $line = <SPSVC>;        # Tag
+               $line = <SPSVC>;        # Branch
+
+               $line = <SPSVC>;
+               if ($line =~ /^Author: (.*)$/) {
+                       $user = $1 unless defined $user && length $user;
+               }
+               else {
+                       error "expected Author, got $line";
+               }
+
+               $line = <SPSVC>;
+               if ($line =~ /^Date: (.*)$/) {
+                       $when = str2time($1, 'UTC');
+               }
+               else {
+                       error "expected Date, got $line";
+               }
+
+               $line = <SPSVC>;
+               if ($line =~ /^PatchSet (.*)$/) {
+                       $rev = $1;
+               }
+               else {
+                       error "expected PatchSet, got $line";
+               }
+
+               $line = <SPSVC>;        # ---------------------
+
+               push @ret, {
+                       rev => $rev,
+                       user => $user,
+                       committype => $committype,
+                       when => $when,
+                       message => [@message],
+                       pages => [@pages],
+               } if @pages;
+               last if @ret >= $num;
+       }
+
+       unlink($tmpfile) || error "couldn't unlink $tmpfile: $!\n";
+
+       return @ret;
+}
+
+sub rcs_diff ($) {
+       my $rev=IkiWiki::possibly_foolish_untaint(int(shift));
+
+       local $CWD = $config{srcdir};
+
+       # diff output is unavoidably preceded by the cvsps PatchSet entry
+       my @cvsps = `env TZ=UTC cvsps -q --cvs-direct -z 30 -g -s $rev`;
+       my $blank_lines_seen = 0;
+
+       while (my $line = shift @cvsps) {
+               $blank_lines_seen++ if ($line =~ /^$/);
+               last if $blank_lines_seen == 2;
+       }
+
+       if (wantarray) {
+               return @cvsps;
+       }
+       else {
+               return join("", @cvsps);
+       }
+}
+
+sub rcs_getctime ($) {
+       my $file=shift;
+
+       my $cvs_log_infoline=qr/^date: (.+);\s+author/;
+
+       open CVSLOG, "cvs -Q log -r1.1 '$file' |"
+               || error "couldn't get cvs log output: $!\n";
+
+       my $date;
+       while (<CVSLOG>) {
+               if (/$cvs_log_infoline/) {
+                       $date=$1;
+               }
+       }
+       close CVSLOG || warn "cvs log $file exited $?";
+
+       if (! defined $date) {
+               warn "failed to parse cvs log for $file\n";
+               return 0;
+       }
+
+       eval q{use Date::Parse};
+       error($@) if $@;
+       $date=str2time($date, 'UTC');
+       debug("found ctime ".localtime($date)." for $file");
+       return $date;
+}
+
+1
index 101c13ee5582ddbf6c33230ae74351497bfa1b69..cd94d093853023b0c7e2c6f29649c4b6d920c220 100644 (file)
@@ -115,7 +115,7 @@ sub test () {
                        # by not testing the removal in such pairs of changes.
                        # (The add is still tested, just to make sure that
                        # no data is added to the repo that a web edit
-                       # could add.)
+                       # could not add.)
                        next if $newfiles{$file};
 
                        if (IkiWiki::Plugin::remove->can("check_canremove")) {
index 246c2260d7748e9fe2b3522d73035564e0fb6754..5953b3feef93c9af06b8a491141635f3552fae82 100644 (file)
@@ -554,6 +554,7 @@ sub refresh () {
        if (%rendered) {
                run_hooks(change => sub { shift->(keys %rendered) });
        }
+       run_hooks(postrefresh => sub { shift->() });
 }
 
 sub commandline_render () {
index ff110b5ffb9763cb5fbb9248c0b5d95bc52fb5e1..53ac5099ac1e197ecac11f0cbbf09562a3aeed91 100644 (file)
@@ -41,6 +41,9 @@ EOF
        my @wrapper_hooks;
        run_hooks(genwrapper => sub { push @wrapper_hooks, shift->() });
 
+       my $check_args="        return 0;";
+       run_hooks(wrapperargcheck => sub { $check_args = shift->(); });
+
        my $check_commit_hook="";
        my $pre_exec="";
        if ($config{post_commit}) {
@@ -113,9 +116,16 @@ addenv(char *var, char *val) {
        newenviron[i++]=s;
 }
 
+int checkargs(int argc, char **argv) {
+$check_args
+}
+
 int main (int argc, char **argv) {
        char *s;
 
+       if (!checkargs(argc, argv))
+               exit(0);
+
 $check_commit_hook
 @wrapper_hooks
 $envsave
index 7f82e717715ef8f446f941f36a154757d6f106ec..aca8da1531c5a51bc594495a15b1f59ad7bc1e55 100755 (executable)
@@ -6,7 +6,7 @@ srcdir="$2"
 repository="$3"
 
 usage () {
-       echo "usage: ikiwiki-makerepo svn|git|monotone|darcs srcdir repository" >&2
+       echo "usage: ikiwiki-makerepo cvs|svn|git|monotone|darcs srcdir repository" >&2
        echo "       ikiwiki-makerepo bzr|mercurial srcdir" >&2
        exit 1
 }
@@ -39,6 +39,30 @@ fi
 echo "Importing $srcdir into $rcs"
 
 case "$rcs" in
+cvs)
+       if [ -e "$srcdir/CVS" ]; then
+               echo "$srcdir already seems to be a cvs working copy" >&2
+               exit 1
+       fi
+       cvs -Q -d "$repository" init
+       cd "$srcdir"/..
+       cvs -Q -d "$repository" get -P CVSROOT
+       cd CVSROOT
+       echo .ikiwiki >> cvsignore
+       cvs -Q add cvsignore
+       echo "^ikiwiki $repository/CVSROOT/post-commit %{sVv} &" >> loginfo
+       cvs -Q commit -m "ikiwiki-makerepo setup" cvsignore loginfo
+       cd ..
+       rm -rf CVSROOT
+       cd "$srcdir"
+       cvs -Q -d "$repository" import -m "initial import" ikiwiki IKIWIKI PRE_CVS
+       cd ..
+       mv "$srcdir" "$srcdir.orig"
+       cvs -Q -d "$repository" get -P -d "$(basename "$srcdir")" ikiwiki
+       [ -d "$srcdir.orig/.ikiwiki" ] && mv "$srcdir.orig/.ikiwiki" "$srcdir"
+       rm -rf "$srcdir.orig"
+       echo "Directory $srcdir is now a checkout of $rcs repository $repository"
+;;
 svn)
        if [ -e "$srcdir/.svn" ]; then
                echo "$srcdir already seems to be a svn working copy" >&2
diff --git a/t/cvs.t b/t/cvs.t
new file mode 100755 (executable)
index 0000000..9df6233
--- /dev/null
+++ b/t/cvs.t
@@ -0,0 +1,71 @@
+#!/usr/bin/perl
+use warnings;
+use strict;
+my $dir;
+BEGIN {
+       $dir="/tmp/ikiwiki-test-cvs.$$";
+       my $cvs=`which cvs`;
+       chomp $cvs;
+       if (! -x $cvs || ! mkdir($dir)) {
+               eval q{
+                       use Test::More skip_all => "cvs not available or could not make test dir"
+               }
+       }
+}
+use Test::More tests => 12;
+
+BEGIN { use_ok("IkiWiki"); }
+
+%config=IkiWiki::defaultconfig();
+$config{rcs} = "cvs";
+$config{srcdir} = "$dir/src";
+$config{cvsrepo} = "$dir/repo";
+$config{cvspath} = "ikiwiki";
+IkiWiki::loadplugins();
+IkiWiki::checkconfig();
+
+my $cvsrepo = "$dir/repo";
+
+system "cvs -d $cvsrepo init >/dev/null";
+system "mkdir $dir/ikiwiki >/dev/null";
+system "cd $dir/ikiwiki && cvs -d $cvsrepo import -m import ikiwiki VENDOR RELEASE >/dev/null";
+system "rm -rf $dir/ikiwiki >/dev/null";
+system "cvs -d $cvsrepo co -d $config{srcdir} ikiwiki >/dev/null";
+
+# Web commit
+my $test1 = readfile("t/test1.mdwn");
+writefile('test1.mdwn', $config{srcdir}, $test1);
+IkiWiki::rcs_add("test1.mdwn");
+IkiWiki::rcs_commit("test1.mdwn", "Added the first page", "moo");
+
+my @changes;
+@changes = IkiWiki::rcs_recentchanges(3);
+
+is($#changes, 0);
+is($changes[0]{message}[0]{"line"}, "Added the first page");
+is($changes[0]{pages}[0]{"page"}, "test1");
+
+# Manual commit
+my $message = "Added the second page";
+
+my $test2 = readfile("t/test2.mdwn");
+writefile('test2.mdwn', $config{srcdir}, $test2);
+system "cd $config{srcdir} && cvs add test2.mdwn >/dev/null 2>&1";
+system "cd $config{srcdir} && cvs commit -m \"$message\" test2.mdwn >/dev/null";
+
+@changes = IkiWiki::rcs_recentchanges(3);
+is($#changes, 1);
+is($changes[0]{message}[0]{"line"}, $message);
+is($changes[0]{pages}[0]{"page"}, "test2");
+is($changes[1]{pages}[0]{"page"}, "test1");
+
+# extra slashes in the path shouldn't break things
+$config{cvspath} = "/ikiwiki//";
+IkiWiki::checkconfig();
+@changes = IkiWiki::rcs_recentchanges(3);
+is($#changes, 1);
+is($changes[0]{message}[0]{"line"}, $message);
+is($changes[0]{pages}[0]{"page"}, "test2");
+is($changes[1]{pages}[0]{"page"}, "test1");
+
+system "rm -rf $dir";
index 7d46c4b7fa9476f59e43b716a9e54e9acef2c4da..a05ad548f948cb87844b370cd05801a2a74938b7 100755 (executable)
@@ -1,7 +1,7 @@
 #!/usr/bin/perl
 use warnings;
 use strict;
-use Test::More tests => 24;
+use Test::More tests => 27;
 
 BEGIN { use_ok("IkiWiki"); }
 
@@ -9,6 +9,9 @@ BEGIN { use_ok("IkiWiki"); }
 
 ok(IkiWiki::file_pruned("src/.ikiwiki/", "src"));
 ok(IkiWiki::file_pruned("src/.ikiwiki/index", "src"));
+ok(IkiWiki::file_pruned("src/CVS", "src"));
+ok(IkiWiki::file_pruned("src/subdir/CVS", "src"));
+ok(IkiWiki::file_pruned("src/subdir/CVS/foo", "src"));
 ok(IkiWiki::file_pruned("src/.svn", "src"));
 ok(IkiWiki::file_pruned("src/subdir/.svn", "src"));
 ok(IkiWiki::file_pruned("src/subdir/.svn/foo", "src"));